#!/usr/bin/env perl
use strict;
use warnings;

use Win32::Sound;
use Array::Contains;
my @lastjobs;

@lastjobs = getJobs();
sleep 5;

while(1) {
    my @newjobs = getJobs();
    my $stuck = 0;
    foreach my $job (@newjobs) {
        if(contains($job, \@lastjobs)) {
            print "Stuck: ", $job, "\n";
            $stuck = 1;
        }
    }
    if($stuck) {
        soundAlarm();
    }
    sleep(10);
}

sub soundAlarm {
    Win32::Sound::Play('warning.wav');
    return;
}

sub getJobs {
    `wmic printjob get jobid, document > printjobs.list`;
    my @joblist;
    open(my $ifh, '<', 'printjobs.list') or die($!);
    while((my $line = <$ifh>)) {
        next if($line =~ /JobId/);
        chomp $line;
        next if(length($line) < 5);
        push @joblist, $line;
    }
    close $ifh;
    return @joblist;
}
